# Build configuration

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 0
%endif

%bcond_without examples

# Versioning

%define qtmajor 6
%define qtminor 4
%define qtsubminor 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 3

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qtlanguageserver-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqtlanguageserver   %mklibname qt%{qtmajor}languageserver %{qtmajor}
%define libqtjsonrpc          %mklibname qt%{qtmajor}jsonrpc %{qtmajor}
%define libqtlanguageserver_d %mklibname qt%{qtmajor}languageserver -d

Name:           qtlanguageserver6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} language server protocol component
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io/
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
#Branch Patchs

#Trunk Patchs

#Patch from Mageia

BuildRequires:  cmake
BuildRequires:  ninja
BuildRequires:  qtbase6-devel = %{version}
BuildRequires:  qtbase6-qtpaths

Provides:       qt%{qtmajor}-qtlanguageserver = %{version}-%{release}

%description
Qt%{qtmajor} language server protocol defines a set of JSON-RPC request,
response and notification messages which are exchanged using the above base
protocol.

#------------------------------------------------------------------------------

%package -n     %{libqtlanguageserver}
Summary:        Qt%{qtmajor} Language Server Library
Group:          System/Libraries
Provides:       qt%{qtmajor}-qtlanguageserver = %{version}-%{release}

Conflicts:      qtlanguageserver6 < 6.4.1-2

%description -n %{libqtlanguageserver}
Qt%{qtmajor} Language Server Component Library.

Qt%{qtmajor} language server protocol defines a set of JSON-RPC request,
response and notification messages which are exchanged using the above base
protocol.

%files -n %{libqtlanguageserver}
%{_qt6_libdir}/libQt%{qtmajor}LanguageServer.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtjsonrpc}
Summary:        Qt%{qtmajor} Json Rpc Library
Group:          System/Libraries
Provides:       qt%{qtmajor}-qtjsonrpc = %{version}-%{release}

Conflicts:      qtlanguageserver6 < 6.4.1-2

%description -n %{libqtjsonrpc}
Qt%{qtmajor} Json Rpc Component Library.

Qt%{qtmajor} language server protocol defines a set of JSON-RPC request,
response and notification messages which are exchanged using the above base
protocol.

%files -n %{libqtjsonrpc}
%{_qt6_libdir}/libQt%{qtmajor}JsonRpc.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n %{libqtlanguageserver_d}
Summary:        Devel files needed to build apps based on QtLanguageServer
Group:          Development/KDE and Qt
Requires:       %{libqtlanguageserver} = %{version}
Requires:       %{libqtjsonrpc} = %{version}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       qt6languageserver-devel = %{version}
Provides:       qt%{qtmajor}-qtlanguageserver-devel = %{version}-%{release}

%description -n %{libqtlanguageserver_d}
Devel files needed to build apps based on Qt LanguageServer.

%files -n %{libqtlanguageserver_d}
%{_qt6_headerdir}/QtLanguageServer/
%{_qt6_libdir}/libQt%{qtmajor}LanguageServer.so
%{_qt6_libdir}/cmake/Qt%{qtmajor}LanguageServerPrivate/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_languageserver_private.pri
%{_qt6_libdir}/libQt%{qtmajor}LanguageServer.prl
%{_qt6_datadir}/modules/*.json
#
%{_qt6_headerdir}/QtJsonRpc/
%{_qt6_libdir}/libQt%{qtmajor}JsonRpc.so
%{_qt6_libdir}/cmake/Qt%{qtmajor}JsonRpcPrivate/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_jsonrpc_private.pri
%{_qt6_libdir}/libQt%{qtmajor}JsonRpc.prl
#
%{_qt6_libdir}/cmake/Qt%{qtmajor}BuildInternals/*/*.cmake
%{_qt6_libdir}/metatypes/qt%{qtmajor}*_metatypes.json

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary:        QtLanguageServer%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools6-assistant
Recommends:     qttools6-assistant

%description doc
Documentation for APIs and tools in QtLanguageServer%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt6_docdir}/qtlanguageserver.qch
%{_qt6_docdir}/qtlanguageserver/
%endif

#------------------------------------------------------------------------------

%prep
%setup -q -n qtlanguageserver-everywhere-src-%{qtversion}

%build
%cmake_qt6 %{!?with_examples:-DQT_BUILD_EXAMPLES:BOOL=OFF}

%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif


%changelog
* Tue Dec 27 2022 daviddavid <daviddavid> 6.4.1-3.mga9
+ Revision: 1927059
- build examples

* Fri Dec 16 2022 daviddavid <daviddavid> 6.4.1-2.mga9
+ Revision: 1923510
- libify pkgs as it should
- own some include and lib dir
- update descriptions and summaries

* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923045
- New version 6.4.1

* Fri Sep 30 2022 neoclust <neoclust> 6.4.0-1.mga9
+ Revision: 1893436
- New version 6.4.0

* Sun Aug 28 2022 papoteur <papoteur> 6.3.1-1.mga9
+ Revision: 1881460
- imported package qtlanguageserver6

